<template>
  <b-modal
    id="applyTemplateModal"
    :model-value="open"
    hide-footer
    size="xl"
    @hidden="close"
  >
    <template #title>
      <span class="h6">{{
        $t(`page.settings.template.apply.modal.title`)
      }}</span>
    </template>

    <!-- Body -->
    <i18n-t
      scope="global"
      :keypath="`page.settings.template.apply.modal.body`"
      tag="p"
      class="mb-3"
    >
      <template #br><br /></template>
    </i18n-t>

    <b-row>
      <b-col sm="5">
        <b-form-group
          :description="$t('page.settings.template.apply.modal.search')"
        >
          <b-form-input
            ref="applySearch"
            v-model="search"
            :placeholder="$t('page.settings.template.apply.modal.search')"
          ></b-form-input>
        </b-form-group>
      </b-col>
      <b-col sm="7">
        <b-button-group class="float-end">
          <b-button
            :variant="editMode ? 'primary' : 'secondary'"
            @click="setEdit"
            >{{ $t("page.settings.template.apply.modal.edit") }}</b-button
          >
          <b-button
            ref="applyPreviewButton"
            :variant="editMode ? 'secondary' : 'primary'"
            @click="setPreview"
            >{{ $t("page.settings.template.apply.modal.preview") }}</b-button
          >
        </b-button-group>
      </b-col>
    </b-row>
    <b-row>
      <b-col sm="5">
        <b-list-group ref="extractedValueList" class="extractedValueList mb-3">
          <b-list-group-item
            v-for="(extractedValue, index) in extractedValueList"
            :key="index"
            draggable="true"
            class="draggable"
            @dragstart="startDrag($event, extractedValue)"
            ><span v-b-tooltip.hover :title="extractedValue.keyFull">{{
              extractedValue.key
            }}</span>
            <span v-b-tooltip.hover :title="extractedValue.valueFull">
              ({{ extractedValue.value }})</span
            ></b-list-group-item
          >
        </b-list-group>
      </b-col>

      <b-col sm="7" class="formGeneratorList">
        <FormGenerator
          v-if="resource && editMode"
          ref="applyEditFormGenerator"
          :key="resource.applicationProfile?.uri + 'true' + fixedValues"
          :fixed-value-mode="true"
          :fixed-values="fixedValues"
          :ignore-template-values="resource.metadataExtraction === true"
          :locale="$i18n.locale"
          :selected-shape="resource.applicationProfile?.uri"
          :shapes="applicationProfile?.definition"
          :template-mode="true"
          :class-receiver="getVocabularyInstances"
          :instance-receiver="getVocabularyInstance"
          :user-receiver="async () => user"
          shape-mime-type="application/ld+json"
          @update:form-data="inputMetadata"
          @update:fixed-values="inputFixedValues"
        />
        <FormGenerator
          v-else-if="resource && !editMode"
          ref="applyViewFormGenerator"
          :key="resource.applicationProfile?.uri + 'false'"
          :ignore-template-values="resource.metadataExtraction === true"
          :locale="$i18n.locale"
          :selected-shape="resource.applicationProfile?.uri"
          :shapes="applicationProfile?.definition"
          :form-data="templatedMetadata"
          :disabled-mode="true"
          :class-receiver="getVocabularyInstances"
          :instance-receiver="getVocabularyInstance"
          :user-receiver="async () => user"
          shape-mime-type="application/ld+json"
        />
      </b-col>
    </b-row>

    <!-- Modal Cancel Button -->
    <b-button @click="close">{{ $t("buttons.cancel") }}</b-button>
    <!-- Modal Archive Button -->
    <b-button
      ref="applyNextButton"
      variant="primary"
      class="float-end"
      @click="next"
    >
      {{ $t(`buttons.next`) }}
    </b-button>
  </b-modal>
</template>

<script lang="ts">
import useResourceStore from "../../../../store";
import useUserStore from "@/modules/user/store";

import factory from "rdf-ext";

import type {
  ResourceDto,
  UserDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import type {
  ApplicationProfileDefinition,
  BilingualLabel,
  BilingualLabels,
} from "../../../../types";
import type { Dataset } from "@rdfjs/types";
import type DatasetExt from "rdf-ext/lib/Dataset";
import type { FixedValues } from "@coscine/form-generator/dist/types/fixedValues";

type ExtractedValue = {
  key: string;
  keyFull: string;
  value: string;
  valueFull: string;
};

export default defineComponent({
  name: "TemplateApplyModal",
  props: {
    applicationProfile: {
      type: [Object, null] as PropType<ApplicationProfileDefinition | null>,
      default: null,
    },
    extractedMetadata: {
      type: [Object, null] as PropType<Dataset | null>,
      default: null,
    },
    fixedValues: {
      type: Object as PropType<FixedValues>,
      default: undefined,
    },
    open: {
      type: Boolean,
      required: true,
    },
  },

  emits: {
    close: () => true,
    "update:fixed-values": (_: FixedValues) => true,
    next: () => true,
  },

  setup() {
    const resourceStore = useResourceStore();
    const userStore = useUserStore();

    return { resourceStore, userStore };
  },

  data() {
    return {
      metadata: factory.dataset() as unknown as Dataset,
      editMode: true,
      search: "",
    };
  },

  computed: {
    resource(): ResourceDto | null {
      return this.resourceStore.currentResource;
    },
    user(): UserDto {
      return this.userStore.user ?? { displayName: undefined };
    },

    extractedValueList(): ExtractedValue[] {
      const extractedValues: ExtractedValue[] = [];
      for (const entry of this.extractedMetadata ?? []) {
        if (
          entry.predicate.value ===
          "http://www.w3.org/1999/02/22-rdf-syntax-ns#type"
        ) {
          continue;
        }
        const predicate = entry.predicate.value;
        const separator = predicate.includes("#") ? "#" : "/";
        const key = predicate.substring(predicate.lastIndexOf(separator) + 1);
        let value = entry.object.value;
        if (value.includes("#")) {
          value = value.substring(value.lastIndexOf("#") + 1);
        }
        if (
          !key.toLowerCase().includes(this.search.toLowerCase()) &&
          !value.toLowerCase().includes(this.search.toLowerCase())
        ) {
          continue;
        }
        extractedValues.push({
          key: key,
          keyFull: entry.predicate.value,
          value: value,
          valueFull: entry.object.value,
        });
      }
      return extractedValues;
    },
    templatedMetadata(): Dataset {
      const clonedMetadata = (
        this.metadata as unknown as DatasetExt
      ).clone() as unknown as Dataset;
      const templateRegex = /\{\{.*?\}\}/g;
      for (const entry of Array.from(clonedMetadata)) {
        if (entry.object.termType !== "Literal") {
          continue;
        }
        const matches = entry.object.value.match(templateRegex);
        if (matches?.length) {
          let adaptedString = entry.object.value;
          for (const match of matches) {
            const urlMatch = match.substring(0, match.length - 2).substring(2);
            const extractedMatches = this.extractedMetadata?.match(
              null,
              factory.namedNode(urlMatch),
            );
            const extractedArray = Array.from(extractedMatches ?? []);
            if (extractedArray.length) {
              adaptedString = adaptedString.replace(
                match,
                extractedArray[0].object.value,
              );
            }
          }
          clonedMetadata.delete(entry);
          clonedMetadata.add(
            factory.quad(
              entry.subject,
              entry.predicate,
              factory.literal(adaptedString, entry.object.datatype),
            ),
          );
        }
      }
      return clonedMetadata;
    },
  },

  methods: {
    close() {
      this.$emit("close");
    },
    next() {
      this.$emit("next");
    },

    startDrag(event: DragEvent, extractedValue: ExtractedValue) {
      if (event.dataTransfer !== null) {
        event.dataTransfer.dropEffect = "copy";
        event.dataTransfer.effectAllowed = "copy";
        event.dataTransfer.setData(
          "text/plain",
          `{{${extractedValue.keyFull}}}`,
        );
      }
    },
    inputMetadata(metadata: Dataset) {
      this.metadata = metadata;
    },
    inputFixedValues(fixedValues: FixedValues) {
      this.$emit("update:fixed-values", fixedValues);
    },
    async getVocabularyInstance(instanceUrl: string): Promise<BilingualLabel> {
      return await this.resourceStore.getVocabularyInstance(instanceUrl);
    },
    async getVocabularyInstances(
      className: string,
      pageNumber: number,
      pageSize: number,
      searchTerm?: string | undefined,
    ): Promise<BilingualLabels> {
      return await this.resourceStore.getVocabularyInstances(
        className,
        pageNumber,
        pageSize,
        searchTerm,
      );
    },
    setEdit() {
      this.editMode = true;
    },
    setPreview() {
      this.editMode = false;
    },
  },
});
</script>

<style scoped>
.extractedValueList {
  overflow-y: auto;
  overflow-x: hidden;
  max-height: 66vh;
}
.formGeneratorList {
  overflow-y: auto;
  overflow-x: hidden;
  max-height: 66vh;
}
.draggable:hover {
  cursor: grab;
}
</style>
